config/routes.rb
Rails.application.routes.draw do

  root 'home#index'

  namespace :auth do
    resources :customers do
      resources :readings, only: [:create, :new, :destroy], controller: '/readings'
    end
    resources :admins, only: [:new, :show]
    resources :users, only: [:new, :create, :show]
  end

  get 'auth/admins/:id/active', to: 'auth/admins#active_customers'
  get 'auth/admins/:id/inactive', to: 'auth/admins#inactive_customers'
  get 'auth/admins/:id/customers', to: 'auth/admins#customers'

  get 'auth/customers/:id/readings', to: 'auth/customers#readings', as: 'customer_readings'

  patch 'auth/admins/:id/verify_customer_icp' => "auth/admins#verify_customer_icp", :as => :verify_customer_icp
  patch 'auth/admins/:id/invalidate_customer_icp' => "auth/admins#invalidate_customer_icp", :as => :invalidate_customer_icp
  
  get 'login', to: 'auth/sessions#new'
  post 'login', to: 'auth/sessions#create'
  delete 'logout', to: 'auth/sessions#destroy'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/reading.rb
class Reading < ApplicationRecord
  belongs_to :user

  validates :kwh, presence:true, numericality: {only_float: true}

  scope :users_readings, -> (user_id) { 
    where(user_id: user_id).order(created_at: :asc) 
  }

  def local_time
    created_at.localtime.strftime("%I:%M%p")
  end

  def local_date
    created_at.localtime.strftime("%d/%m/%y")
  end

  def kwph
    kwh.to_f
  end
end

app/models/user.rb
class User < ApplicationRecord

  CUSTOMER = "customer"
  ADMIN = "admin"

  has_many :readings
  before_save :downcase_name
  validates_presence_of :name
  validates_presence_of :address,
                        :icp,
                        unless: :admin?

  validates :name, uniqueness: true
  validates :icp, 
    format: { with: /\A[0-9]+\z/, message: "must contain only numbers" },
    length: { is: 9 },
    unless: :admin?

  scope :active, -> { where(active: true, role: CUSTOMER) }
  scope :inactive, -> { where(active: false, role: CUSTOMER) }
  scope :customers, -> { where(role: CUSTOMER) }

  def downcase_name
    self.name.downcase!
  end
  
  def admin?
    role == ADMIN
  end

  def customer?
    role == CUSTOMER
  end

  def activate
    update_attribute(:active, true)
  end

  def invalidate
    update_attribute(:active, false)
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  def index
  end
end

app/controllers/readings_controller.rb
class ReadingsController < Auth::BaseController

  before_action :find_customer, only: [:new, :create]

  def new
    @reading = @customer.readings.build
  end

  def create
    @reading = @customer.readings.build(readings_params)
    read = ValidateReading.new(reading: @reading).call

    if read.success
      redirect_to customer_readings_path(@customer.id)
    else
      redirect_to new_auth_customer_reading_path(@customer.id), notice: read.error.flatten
    end
  end

  def destroy
    reading = Reading.find(params[:id])
    reading.delete
    redirect_back(fallback_location: root_path)
  end

  private

  def find_customer
    @customer = User.find(params[:customer_id])
  end

  def readings_params
    params.require(:reading).permit(:kwh)
  end
end

app/helpers/admins_helper.rb
module AdminsHelper
  def active?(activated)
    activated ? "Deactivate" : "Activate"
  end
end

app/helpers/application_helper.rb
module ApplicationHelper

end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/home/index.html.erb
<div class="jumbotron">
  <div class="container">
    <h1 class="display-3">Hello MiniShoper!</h1>
    <p>This is a template for a simple marketing or informational website. It includes a large callout called a jumbotron and three supporting pieces of content. Use it as a starting point to create something more unique.</p>
  </div>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>MiniShop</title>
    <%= csrf_meta_tags %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
    <script src="https://code.jquery.com/jquery-3.2.1.min.js" integrity="sha256-hwg4gsxgFZhOsEEamdOYGBf13FyQuiTwlAQgxVSNgt4=" crossorigin="anonymous"></script>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0-beta.2/css/bootstrap.min.css" integrity="sha384-PsH8R72JQ3SOdhVi3uxftmaW6Vc51MKb0q5P2rRUpPvrszuE4W1povHYgTpBfshb" crossorigin="anonymous">
    <script src="https://use.fontawesome.com/a846fde3c2.js"></script>
  </head>
  <body>
    <nav class="nav nav-tabs-purple">
      <%= link_to "Home", root_path, class: "nav-link" %>
      <% if logged_in? %>
        <%= link_to "LogOut", logout_path, method: :delete, class: "nav-link" %>
        <% if @current_user.admin? %>
          <%= link_to "Admin", auth_admin_path(@current_user.id), class: "nav-link profile-link" %>
        <% elsif @current_user.customer? %>
          <%= link_to "Profile", auth_customer_path(@current_user.id), class: "nav-link profile-link" %>
        <% end %>
      <% else %>
        <%= link_to 'SignUp', new_auth_user_path, class: "nav-link" %>
        <%= link_to 'LogIn', login_path, class: "nav-link" %>
      <% end %>
    </nav>
    <%= yield %>
    <script type="text/javascript">
    </script>
  </body>
</html>

app/views/readings/new.html.erb
<div class="container-fluid sign-up-page">
  <div class="row">
    <div class="col-4">
    </div>
    <div class="col-4">
      <%= form_for @reading, as: :reading, url: auth_customer_readings_path(@customer, @reading), method: :post  do |f| %>
        <div class="form-group">
          <%= f.label :kwh, "KWH Reading" %>
          <%= f.text_field :kwh, class: "form-control" %>
        </div>
        <%= f.submit class: "btn btn-primary" %>
      <% end %>
      <h2 class="flash-notice"><%= flash[:notice] %></h2>
    </div>
    <div class="col-4">
    </div>
  </div>
</div>